#include <libwccl/lexicon/lexiconparser.h>
#include "ANTLRLexiconParser.hpp"
#include "ANTLRLexiconLexer.hpp"

#include <libwccl/lexicon/lexicon.h>
#include <libwccl/exception.h>

#include <fstream>

namespace Wccl {

boost::shared_ptr<Lexicon> LexiconParser::parse_lexicon(
	const std::string& lexicon_name,
	const std::string& path)
{
	std::ifstream is(path.c_str());
	if (!is.good()) {
		throw Wccl::FileNotFound(path, "", __FUNCTION__);
	}

	ANTLRLexiconLexer lexer(is);
	ANTLRLexiconParser parser(lexer);
	return parser.parse_lexicon_file(lexicon_name);
}

} /* end ns Wccl */
